// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::DockManager;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDock")]
    pub struct Dock(Interface<ffi::DzlDock, ffi::DzlDockInterface>) @requires gtk::Container, gtk::Widget, gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_dock_get_type(),
    }
}

impl Dock {
    pub const NONE: Option<&'static Dock> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Dock>> Sealed for T {}
}

pub trait DockExt: IsA<Dock> + sealed::Sealed + 'static {
    fn manager(&self) -> Option<DockManager> {
        ObjectExt::property(self.as_ref(), "manager")
    }

    fn set_manager<P: IsA<DockManager>>(&self, manager: Option<&P>) {
        ObjectExt::set_property(self.as_ref(), "manager", manager)
    }

    #[doc(alias = "manager")]
    fn connect_manager_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_manager_trampoline<P: IsA<Dock>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDock,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Dock::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::manager\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_manager_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<Dock>> DockExt for O {}

impl fmt::Display for Dock {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Dock")
    }
}
